/*    
    This file is part of Display Quota, a Thunderbird Extension

    Display Quota is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Display Quota is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Display Quota.  If not, see <http://www.gnu.org/licenses/>.

*/

var gQuotaUICache;

//////////////////////////////////////////////////////////////////////////////////
// our javascript namespace object
/////////////////////////////////////////////////////////////////////////////////

if(typeof ChromeUtils.import == 'function') {
	ChromeUtils.import("resource:///modules/MailUtils.jsm");
} else {
	Components.utils.import("resource:///modules/MailUtils.js");
}

if ("undefined" == typeof(DisplayQuota)) {  
  var DisplayQuota = {  
     alertDialog: null,
     lap: 900000,      // 15 minutes between notifications
     currentServerName: null,
     elapsed: 10000000,
     debug: 0,
     firstwarn: 1,
     whenusenotif: 2,
     donotbug: false,
     warnpercent: 90,
     showpercent: 0,
     lastwarn: "0",
     lastpercentage: 0,


     // https://bugzilla.mozilla.org/show_bug.cgi?id=889022
     getMsgFolderFromUri:  function(uri, checkFolderAttributes) {

     	let msgfolder = null;
        if (typeof MailUtils != 'undefined' && MailUtils.getFolderForURI) {
        	return MailUtils.getFolderForURI(uri, checkFolderAttributes);
         }
         try {
         	var RDF = Cc["@mozilla.org/rdf/rdf-service;1"].getService(Ci.nsIRDFService);         
         	let resource = RDF.GetResource(uri);
                msgfolder = resource.QueryInterface(Components.interfaces.nsIMsgFolder);
                if (checkFolderAttributes) {
                	if (!(msgfolder && (msgfolder.parent || msgfolder.isServer))) {
                        	msgfolder = null;
                        }
                }
          }
          catch (ex) {
          	console.log("failed to get the folder resource:"+ex+"\n");   
          }
          return msgfolder;
      },
                                                                                                                                                                                                                                                                                                                                                                                                                 
      // checkQuota 
      checkQuota: function(item,event) {
        if(DisplayQuota.debug == 2) console.log("DQ: In checkQuota\n");
	var DisplayQuotaPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var DisplayQuotaStrBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
	var mMsgFolder;

	try {
		var DisplayQuotaStrBundle = DisplayQuotaStrBundleService.createBundle("chrome://displayquota/locale/displayquota.properties");
	} catch (ex) { if(DisplayQuota.debug) console.log("DQ: Erreur de chargement: " + ex + "\n"); }

	if(DisplayQuota.debug == 2) console.log("DQ: etape 1\n");

        try {
          var selectedURI; //= DisplayQuota._getSelectedFolderURI();
          if(typeof GetSelectedFolderURI != 'function') {
            var selectedFolders = gFolderTreeView.getSelectedFolders();
            selectedURI = selectedFolders[0].URI;
          } else {
            selectedURI = GetSelectedFolderURI(); 
          }
	} catch (ex) {
	  if(DisplayQuota.debug) console.log("DQ: erreur de GetSelectedFolderURI " + ex + "\n");
	}
	if(DisplayQuota.debug == 2) console.log("DQ: etape 1.1 " + selectedURI + "\n");	

	try {
	  if(!RDF) 
	    var RDF = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService(Components.interfaces.nsIRDFService);
	  var folderResource = RDF.GetResource(selectedURI);
	} catch (ex) {
        	if(DisplayQuota.debug) console.log("DQ: erreur de RDF.GetResource " + ex + "\n");
	}
	if(DisplayQuota.debug == 2) console.log("DQ: etape 1.2\n");		

	if (folderResource) mMsgFolder = folderResource.QueryInterface(Components.interfaces.nsIMsgFolder);

	if(DisplayQuota.debug == 2) console.log("DQ: etape 2\n");

        var msgFolder = DisplayQuota.getMsgFolderFromUri(selectedURI, true);
        
        if(DisplayQuota.debug == 2) console.log("DQ: warnpercent is "+DisplayQuota.warnpercent+"\n");
        if(DisplayQuota.debug == 2) console.log("DQ: showpercent is "+DisplayQuota.showpercent+"\n");        
        
        DisplayQuota.updateQuota(msgFolder);
        
	var serverType = msgFolder.server.type;
	if(DisplayQuota.debug == 2) console.log("DQ: PrettyName: "+ msgFolder.server.prettyName + "  currentServerName: " + DisplayQuota.currentServerName + "\n" );
	if ( msgFolder.server.prettyName != DisplayQuota.currentServerName ) {
		DisplayQuota.currentServerName = msgFolder.server.prettyName;
		DisplayQuota.firstwarn = 1;
		if(DisplayQuota.debug == 2) console.log("DQ: DisplayQuota.firstwarn: " + DisplayQuota.firstwarn  +"\n" );		
	}

        if(DisplayQuota.debug == 2) console.log("DQ: "+ DisplayQuota.currentServerName + "  " + serverType + " : " + event + "\n" );	

	if(serverType == "imap") {
		var imapFolder = mMsgFolder.QueryInterface(Components.interfaces.nsIMsgImapMailFolder);
    		if (imapFolder) {
			imapFolder.fillInFolderProps(DisplayQuotaFolderPropsSink);
		}
	} else { 
//		var quotaStatusBar = document.getElementById('DisplayQuota-statusbar');
//		var quotaProgress = document.getElementById('DisplayQuota-progress-icon');
//		var quotaLabelPC = document.getElementById('DisplayQuota-percent');

		var notimap = DisplayQuotaStrBundle.GetStringFromName("notimap");
 //     		quotaProgress.setAttribute("tooltiptext",notimap);
//		quotaLabelPC.setAttribute("value","");
//		quotaProgress.setAttribute("value",0);		
	}
	if(DisplayQuota.debug == 2) console.log("DQ: Out checkQuota\n");
      },

      // originally from https://dxr.mozilla.org/comm-central/source/comm/mail/base/content/commandglue.js#125
      updateQuota: function(folder) {
        if (!(folder && // no folder selected
          folder instanceof Ci.nsIMsgImapMailFolder)) { // POP etc.
      		if (typeof(gQuotaUICache) == "object") // ever shown quota
      			gQuotaUICache.panel.hidden = true;
		return;
	}
	folder = folder.QueryInterface(Ci.nsIMsgImapMailFolder);

	const kBranch = "mail.quota.mainwindow_threshold.";

	// get element references and prefs
	if (typeof(gQuotaUICache) != "object") {
	
		gQuotaUICache = new Object();
		gQuotaUICache.meter = document.getElementById("quotaMeter");
		gQuotaUICache.panel = document.getElementById("quotaPanel");
		gQuotaUICache.label = document.getElementById("quotaLabel");
	}
	// overwrite default preferences no matter what.
	gQuotaUICache.showTreshold = DisplayQuota.showpercent;
	gQuotaUICache.warningTreshold = DisplayQuota.warnpercent;
	gQuotaUICache.criticalTreshold = Services.prefs.getIntPref(kBranch + "critical");		
	if(DisplayQuota.debug == 2) console.log("DQ: in updateQuota : show is "+gQuotaUICache.showTreshold+" warning is "+gQuotaUICache.warningTreshold+" critical is "+gQuotaUICache.criticalTreshold);
	var valid = {value: null};
	var used = {value: null};
	var max = {value: null};
	try {
		// get data from backend
		folder.getQuota(valid, used, max);
	} catch (e) { console.log(e + "\n"); }
	if (valid.value && max.value > 0) {
		var percent = Math.round(used.value / max.value * 100);
		// show in UI
		if (percent < gQuotaUICache.showTreshold)
			gQuotaUICache.panel.hidden = true;
		else {
			gQuotaUICache.panel.hidden = false;
			gQuotaUICache.meter.setAttribute("value", percent);
			// do not use value property, because that is imprecise (3%)
			// for optimization that we don't need here
			var bundle = document.getElementById("bundle_messenger");
			var label = bundle.getFormattedString("percent", [percent]);
			var tooltip = bundle.getFormattedString("quotaTooltip",[used.value, max.value]);
			gQuotaUICache.label.value = label;
			gQuotaUICache.label.tooltipText = tooltip;
			if (percent < gQuotaUICache.warningTreshold)
				gQuotaUICache.panel.removeAttribute("alert");
			else if (percent < gQuotaUICache.criticalTreshold)
				gQuotaUICache.panel.setAttribute("alert", "warning");
			else
				gQuotaUICache.panel.setAttribute("alert", "critical");
		}
	} else gQuotaUICache.panel.hidden = true;
       },
      

      // addToSession
      addToSession: function() {
        if(DisplayQuota.debug == 2) console.log("DQ: In DisplayQuotaAddToSession\n");
	var mailSessionContractID = "@mozilla.org/messenger/services/session;1";
	try {
          // @mozilla.org/messenger/services/session;1 is reprecated: cf patch https://bugzilla.mozilla.org/show_bug.cgi?id=736870 to use mailService
          // Some JS modules were moved from `resource:///` and `resource://gre/` to `resource://app/`. See bug https://bugzilla.mozilla.org/show_bug.cgi?id=763295 for more information.
          if(typeof ChromeUtils.import == 'function') {
          ChromeUtils.import("resource:///modules/MailServices.jsm");
          ChromeUtils.import("resource:///modules/MailUtils.jsm");
          ChromeUtils.import("resource://gre/modules/Services.jsm");
	  } else {
          	Components.utils.import("resource://app/modules/mailServices.js");          	
          }
          
          //var mailSession = Components.classes[mailSessionContractID].getService(Components.interfaces.nsIMsgMailSession);
          var nsIFolderListener = Components.interfaces.nsIFolderListener;
          var notifyFlags = nsIFolderListener.event;
          var DisplayQuotafolderListener = {
            OnItemAdded: function(parent, item, viewString) {},
            OnItemRemoved: function(parent, item, viewString) {},
            OnItemPropertyChanged: function(parent, item, viewString) {},
            OnItemIntPropertyChanged: function(item, property, oldValue, newValue) {},
            OnItemBoolPropertyChanged: function(item, property, oldValue, newValue) {},
            OnItemUnicharPropertyChanged: function(item, property, oldValue, newValue) {},
            OnItemPropertyFlagChanged: function(item, property, oldFlag, newFlag) {},
            OnItemEvent: DisplayQuota.checkQuota,
            OnDeleteOrMoveMessagesCompleted: function( aFolder) {}
          };
        
          //mailSession.AddFolderListener(DisplayQuotafolderListener, notifyFlags);
           MailServices.mailSession.AddFolderListener(DisplayQuotafolderListener, notifyFlags);
        } catch (ex) { 
       	  if(DisplayQuota.debug) { console.log("DQ: Error adding to session: "+ex+"\n"); }
	} 
        if(DisplayQuota.debug == 2) console.log("DQ: Out DisplayQuotaAddToSession\n");
      },

      // init
      init: function() {
        if(DisplayQuota.debug == 2) console.log("DQ: In DisplayQuotaInit\n");
	var pastDate = new Date("February 5, 2001 23:15:00");
	var DisplayQuotaPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.lastwarn") == DisplayQuotaPrefs.PREF_STRING) {
		DisplayQuotaPrefs.setCharPref("extension.displayquota.lastwarn",pastDate);
	}
	
	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.whenusenotif") == DisplayQuotaPrefs.PREF_INT) {
		DisplayQuota.whenusenotif = DisplayQuotaPrefs.getIntPref("extension.displayquota.whenusenotif");
	}

	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.warnpercent") == DisplayQuotaPrefs.PREF_INT){
		DisplayQuota.warnpercent = DisplayQuotaPrefs.getIntPref("extension.displayquota.warnpercent");	
	}
	
	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.showpercent") == DisplayQuotaPrefs.PREF_INT){
		DisplayQuota.showpercent = DisplayQuotaPrefs.getIntPref("extension.displayquota.showpercent");	
	}	

	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.lastpercentage") == DisplayQuotaPrefs.PREF_INT){
		DisplayQuota.lastpercentage = DisplayQuotaPrefs.getIntPref("extension.displayquota.lastpercentage");	
	}

/*	window.addEventListener("MailViewChanged",
		function(aEvent){
			DisplayQuota.updateDisplay(aEvent);
		});
*/
	
	/*if (DisplayQuotaPrefs.getPrefType("extension.displayquota.debug") == DisplayQuotaPrefs.PREF_BOOL) {
	  debug = DisplayQuotaPrefs.getIntPref("extension.displayquota.debug");
	}*/
	if(DisplayQuota.debug == 2) console.log("DQ: Out DisplayQuotaInit\n");
      },

    }
};

//////////////////////////////////////////////////////////////////////////////////
// container for all the folder properties
/////////////////////////////////////////////////////////////////////////////////
var DisplayQuotaFolderPropsSink = {
    setFolderType: function(folderTypeString) {},
    setFolderTypeDescription: function(folderDescription) {},
    setFolderPermissions: function(folderPermissions) {},
    serverDoesntSupportACL : function() {},
    setQuotaStatus : function() {},

    showQuotaData : function(showData) {
    
        if(DisplayQuota.debug == 2) console.log("DQ: In ShowQuotaData\n");
      
//	var quotaStatusBar = document.getElementById('DisplayQuota-statusbar');
//	var quotaProgress = document.getElementById('DisplayQuota-progress-icon');
//	var quotaLabelPC = document.getElementById('DisplayQuota-percent');

	var DisplayQuotaPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var DisplayQuotaStrBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
	var DisplayQuotaStrBundle = DisplayQuotaStrBundleService.createBundle("chrome://displayquota/locale/displayquota.properties");
	
      	if(showData == false) {
		var noquota = DisplayQuotaStrBundle.GetStringFromName("noquota");
//      		quotaProgress.setAttribute("tooltiptext",noquota);
//		quotaLabelPC.setAttribute("value","");
//		quotaProgress.setAttribute("value",0);	
      	}
      	
      	if(DisplayQuota.debug == 2) console.log("DQ: Out ShowQuotaData\n"); 
    },

    setQuotaData : function(root, usedKB, maxKB)
    {
    
        if(DisplayQuota.debug == 2) console.log("DQ: In SetQuotaData\n");
    
/*      	var quotaStatusBar = document.getElementById('DisplayQuota-statusbar');
      	var quotaProgress = document.getElementById('DisplayQuota-progress-icon');
        var quotaLabelText = document.getElementById('DisplayQuota-text');
	var quotaLabelPC = document.getElementById('DisplayQuota-percent');
	var quotaIcon = document.getElementById('DisplayQuota-icon');
*/	
	// disable thunderbird's default quota progressbar
/*	var quotaPanel = document.getElementById('quotaPanel');
	if(quotaPanel && quotaPanel.getAttribute("hidden") != "true") {
	  if(DisplayQuota.debug) console.log("DQ: quotaPanel is there, hidding it\n");
	  quotaPanel.setAttribute("hidden","true");
        }
*/
	var DisplayQuotaPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

	var DisplayQuotaStrBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);

	try {
		var DisplayQuotaStrBundle = DisplayQuotaStrBundleService.createBundle("chrome://displayquota/locale/displayquota.properties");
	} catch (ex) { if(DisplayQuota.debug) console.log("DQ: erreur bundle: " + ex + "\n"); }


	/*if (DisplayQuotaPrefs.getPrefType("extension.displayquota.debug") == DisplayQuotaPrefs.PREF_BOOL) {
	  DisplayQuota.debug = DisplayQuotaPrefs.getIntPref("extension.displayquota.debug");
	}*/

	//if(DisplayQuota.debug == 2) console.log("DQ: "+DisplayQuota.currentServerName + ": in setQuota \n");

	// get the values from the perferences
	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.whenusenotif") == DisplayQuotaPrefs.PREF_INT) {
		DisplayQuota.whenusenotif = DisplayQuotaPrefs.getIntPref("extension.displayquota.whenusenotif");
	}

	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.warnpercent") == DisplayQuotaPrefs.PREF_INT){
		DisplayQuota.warnpercent = DisplayQuotaPrefs.getIntPref("extension.displayquota.warnpercent");	
	}
	
	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.showpercent") == DisplayQuotaPrefs.PREF_INT){
		DisplayQuota.showpercent = DisplayQuotaPrefs.getIntPref("extension.displayquota.showpercent");	
	}	

	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.lastwarn") == DisplayQuotaPrefs.PREF_STRING){
		var tmpDate = new Date(DisplayQuotaPrefs.getCharPref("extension.displayquota.lastwarn"));
		DisplayQuota.lastwarn = tmpDate.getTime();
	}

	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.lastpercentage") == DisplayQuotaPrefs.PREF_INT){
		DisplayQuota.lastpercentage = DisplayQuotaPrefs.getIntPref("extension.displayquota.lastpercentage");	
	}

//	if (DisplayQuotaPrefs.getPrefType("extension.displayquota.progressbarwidth") == DisplayQuotaPrefs.PREF_INT){
//             quotaProgressWidth=DisplayQuotaPrefs.getIntPref("extension.displayquota.progressbarwidth");
//		quotaProgress.setAttribute("width",quotaProgressWidth);
//        }
        
        // let's calculate our values and units
	var percentage = (maxKB != 0) ? Math.round(usedKB / maxKB * 100) : 0;

	var unitMax = DisplayQuotaStrBundle.GetStringFromName("kilobyte");
	var unitUsed = DisplayQuotaStrBundle.GetStringFromName("kilobyte");

      	var niceUsed = usedKB;
      	var niceMax = maxKB / 1024;
 
      	if(usedKB >= 1024) {
		unitUsed = DisplayQuotaStrBundle.GetStringFromName("megabyte");
	 	niceUsed =  usedKB / 1024;	
      	}
      	if(niceUsed >= 1024) {
		unitUsed = DisplayQuotaStrBundle.GetStringFromName("gigabyte");
		niceUsed =  niceUsed / 1024;	
      	}
      
	if(niceMax >= 1024) {
		niceMax = niceMax / 1024;
		unitMax = DisplayQuotaStrBundle.GetStringFromName("gigabyte");
      	} else {
      		unitMax = DisplayQuotaStrBundle.GetStringFromName("megabyte");
      	}
      	
      	if(DisplayQuota.debug) 
      	  console.log("DQ: "+DisplayQuota.currentServerName+" [whenusenotif: "+DisplayQuota.whenusenotif+"] [percentage: "+ percentage +"] showpercent: "+ DisplayQuota.showpercent +"] [warnpercent: "+ DisplayQuota.warnpercent +"] [usedKB: "+ usedKB +"] [niceUsed: "+ niceMax +"] [firstwarn: "+ DisplayQuota.firstwarn +"]\n");
      	
      	// update the progress bar
//	quotaProgress.setAttribute("value",percentage);
//      	quotaLabelPC.setAttribute("value",percentage+"%");
	
	var usage = DisplayQuotaStrBundle.GetStringFromName("usage");
	var of = DisplayQuotaStrBundle.GetStringFromName("of");

	var alertsService = Components.classes["@mozilla.org/alerts-service;1"].getService(Components.interfaces.nsIAlertsService);

/*  	quotaProgress.setAttribute("tooltiptext",usage  + ": " + niceUsed.toFixed(2) + " " + unitUsed  + " " + of + " " +  niceMax.toFixed(2) + " " + unitMax + " (" + percentage +"%)");
      	if (percentage < 50) quotaLabelPC.setAttribute("status","normal");
      	if (percentage >= 50) quotaLabelPC.setAttribute("status","middle");
      	if (percentage >= warnpercent) quotaLabelPC.setAttribute("status","warning");
	if (percentage >= 90) quotaLabelPC.setAttribute("status","alert");
      	if (percentage >= 100) {
		quotaLabelPC.setAttribute("status","over");
		quotaIcon.setAttribute("hidden","false");
		quotaIcon.setAttribute("src","chrome://displayquota/skin/petit-emblem-unreadable.png");
      	}
*/      	
      	// check if we need to show the notification
	if (percentage >= DisplayQuota.warnpercent) {


		var warn1 = DisplayQuotaStrBundle.GetStringFromName("warnalert1");
		var warn2 = DisplayQuotaStrBundle.GetStringFromName("warnalert2");
		var overalert= DisplayQuotaStrBundle.GetStringFromName("overalert");
		var overalert2= DisplayQuotaStrBundle.GetStringFromName("overalert2");

//		quotaIcon.setAttribute("hidden","false");
		
		if (DisplayQuota.alertDialog) {
			DisplayQuota.alertDialog.close();
			DisplayQuota.alertDialog = null;
		}

		var currentDate = new Date();
		var currentTime = currentDate.getTime();
		DisplayQuota.elapsed = currentTime - DisplayQuota.lastwarn;

                if(DisplayQuota.debug) console.log("DQ: [elapsed: " + DisplayQuota.elapsed + "] [lap: "+DisplayQuota.lap+"]\n");

		if (DisplayQuota.elapsed >= DisplayQuota.lap || DisplayQuota.firstwarn==1) {
			DisplayQuotaPrefs.setCharPref("extension.displayquota.lastwarn",currentDate);
			if(DisplayQuota.debug) console.log("DQ: " + DisplayQuota.currentServerName + " percentage >= warnpercent: notifying && elapsed >= lap && firstwarn == 1\n");
			
			if(percentage >= 100) { 
				//var notificationtitle = DisplayQuotaStrBundle.GetStringFromName("quotaalert");
				var notificationtitle = DisplayQuota.currentServerName;
				var notificationmsg = overalert+" "+overalert2;
				// show notification unless setting says "never"
				if(DisplayQuota.debug) console.log("DQ: " + notificationtitle +" "+notificationmsg+"\n");				
				if(DisplayQuota.whenusenotif<3) alertsService.showAlertNotification("chrome://displayquota/skin/emblem-unreadable.png",notificationtitle,notificationmsg,false, "", null);	
                                else if(DisplayQuota.debug) console.log("DQ: whenusenotif is "+ DisplayQuota.whenusenotif+"\n");
			}
			else {
				//var notificationtitle = DisplayQuotaStrBundle.GetStringFromName("quotawarning");
				var notificationtitle = DisplayQuota.currentServerName;
				var notificationmsg = warn1 + " " + percentage + "% "+ warn2;
				// show notification unless setting says "never"
				alertsService.showAlertNotification("chrome://displayquota/skin/emblem-important.png",notificationtitle,notificationmsg,false, "", null);		
//				quotaIcon.setAttribute("src","chrome://displayquota/skin/petit-emblem-important.png");
			}
			DisplayQuota.firstwarn=0;
		}
 	} else {
		var warn1 = DisplayQuotaStrBundle.GetStringFromName("warnalert1");
		var warn2 = DisplayQuotaStrBundle.GetStringFromName("warnalert2");
		
		if (DisplayQuota.firstwarn==1) {
			var currentDate = new Date();
			DisplayQuotaPrefs.setCharPref("extension.displayquota.lastwarn",currentDate);
			//var notificationtitle = DisplayQuotaStrBundle.GetStringFromName("quotainfo");
			var notificationtitle = DisplayQuota.currentServerName;
			var notificationmsg = warn1 + " " + percentage + "% "+ warn2;
			if(DisplayQuota.whenusenotif==1) {
			  if(DisplayQuota.debug) console.log("DQ: [whenusenotif: 1] always show notification\n");
			  alertsService.showAlertNotification("chrome://displayquota/skin/quota-ok.png",notificationtitle,notificationmsg,false, "", null);		
                        } else if(DisplayQuota.debug) console.log("DQ: whenusenotif is "+ DisplayQuota.whenusenotif+"\n");
		}
		DisplayQuota.firstwarn=0;
	}

//	if (percentage < warnpercent) quotaIcon.setAttribute("hidden","true");

	if(DisplayQuota.debug == 2) console.log("DQ: Out SetQuotaData\n");

	}
};




// init...
if(DisplayQuota.debug) console.log("DQ sez Hello\n");
DisplayQuota.init();
DisplayQuota.addToSession();

