/*    
    This file is part of Display Quota, a Thunderbird Extension

    Display Quota is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Display Quota is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Display Quota.  If not, see <http://www.gnu.org/licenses/>.

*/

if ("undefined" == typeof(DisplayQuotaAlert)) {  
  var DisplayQuotaAlert = {

          // get values from the prefs
          onLoad: function() {
                  var currentAlert = "";
                  var percentage = window.arguments[0];
                  var status="good";       
                  var alertText1         = document.getElementById('DisplayQuotaAlertDesc1');
                  var alertText2         = document.getElementById('DisplayQuotaAlertDesc2');
                  var Icon         	= document.getElementById('DisplayQuotaAlertIcon');
                  var DisplayQuotaPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
                  var DisplayQuotaStrBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
                  var DisplayQuotaStrBundle = DisplayQuotaStrBundleService.createBundle("chrome://displayquota/locale/displayquota.properties");

                  var warn1 = DisplayQuotaStrBundle.GetStringFromName("warnalert1");
                  var warn2 = DisplayQuotaStrBundle.GetStringFromName("warnalert2");
                  var warn3 = DisplayQuotaStrBundle.GetStringFromName("warnalert3");
                  var over = DisplayQuotaStrBundle.GetStringFromName("overalert");
                  var over2 = DisplayQuotaStrBundle.GetStringFromName("overalert2");	
	
                  currentAlert = warn1 + " " + percentage + "% " + warn2 + " " + warn3;	

                  if(percentage >= 50) status="ok";
                  if(percentage >= 70) status="warning1";
                  if(percentage >= 80) status="warning2";
                  if(percentage >= 90) status="warning3";
                  if(percentage >= 100) {
                          status="over";
                          Icon.setAttribute("class","error-icon");
                          currentAlert = over+" "+over2;
                  }

                  alertText1.setAttribute("status",status);
                  alertText2.setAttribute("status",status);

                  alertText1.setAttribute("value",currentAlert);
                  alertText2.setAttribute("value",currentAlert);

          },

          onAccept: function() {
                  var percentage = window.arguments[0];
                  var donotbug = document.getElementById('DisplayQuotaAlertDontBugMe');
                  var checked = donotbug.getAttribute("checked");

                  if(checked == "true") {
                          var currentDate = new Date();
                          var DisplayQuotaPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
                          DisplayQuotaPrefs.setCharPref("extension.displayquota.lastwarn",currentDate);
                          DisplayQuotaPrefs.setBoolPref("extension.displayquota.donotbug",true);
                          DisplayQuotaPrefs.setIntPref("extension.displayquota.lastpercentage",percentage);
                  }

                  return true;	
          }
  };
}         