/*    
    This file is part of Display Quota, a Thunderbird Extension

    Display Quota is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Display Quota is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Display Quota.  If not, see <http://www.gnu.org/licenses/>.

*/


if ("undefined" == typeof(DisplayQuotaOptions)) {  
  var DisplayQuotaOptions = {
          debug: true,
      
          // if the user click on "OK"
          onAccept: function() {   
                  if(this.debug) console.log("DQ: in onAccept");
                  var warnpercent = document.getElementById('DisplayQuotaFirstWarnPercent');
                  var whenusenotif = document.getElementById('DisplayQuotaWhenUseNotif');
                  var showpercent = document.getElementById('DisplayQuotaShowPercent');

                  var DisplayQuotaPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

                  DisplayQuotaPrefs.setIntPref("extension.displayquota.warnpercent",warnpercent.getAttribute("value"));
                  DisplayQuotaPrefs.setIntPref("extension.displayquota.showpercent",showpercent.getAttribute("value"));                  
                  if(this.debug) console.log("Whenusenotif: " + whenusenotif.getAttribute("value"));
                  DisplayQuotaPrefs.setIntPref("extension.displayquota.whenusenotif",whenusenotif.getAttribute("value"));
                  if(this.debug) console.log("DQ: out onAccept");                  
          },


          // get values from the prefs
          onLoad: function() {
                  if(this.debug) console.log("DQ: in onLoad");
                  var warnpercent;
                  var showpercent;                  
                  var whenusenotif;
                  var DisplayQuotaPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
                  var warnpercentlist = document.getElementById('DisplayQuotaFirstWarnPercent');
                  var showpercentlist = document.getElementById('DisplayQuotaShowPercent');                  
                  var whenusenotiflist = document.getElementById('DisplayQuotaWhenUseNotif');

                  // setting up the dialog with the preferences' values
                  if (DisplayQuotaPrefs.getPrefType("extension.displayquota.warnpercent") == DisplayQuotaPrefs.PREF_INT){
                          warnpercent = DisplayQuotaPrefs.getIntPref("extension.displayquota.warnpercent");
                          var elements = warnpercentlist.getElementsByAttribute("value",warnpercent);
                          warnpercentlist.selectedItem = elements[0];
                  } 
                  
                  if (DisplayQuotaPrefs.getPrefType("extension.displayquota.showpercent") == DisplayQuotaPrefs.PREF_INT){
                          showpercent = DisplayQuotaPrefs.getIntPref("extension.displayquota.showpercent");
                          var elements = showpercentlist.getElementsByAttribute("value",showpercent);
                          showpercentlist.selectedItem = elements[0];
                  }                   

                  if (DisplayQuotaPrefs.getPrefType("extension.displayquota.whenusenotif") == DisplayQuotaPrefs.PREF_INT) {
                          whenusenotif = DisplayQuotaPrefs.getIntPref("extension.displayquota.whenusenotif");
                          if(this.debug) console.log("got usenotif from prefs: " + whenusenotif);
                          var elements = whenusenotiflist.getElementsByAttribute("value",whenusenotif);
                          whenusenotiflist.selectedItem = elements[0];
                  } else {
                          whenusenotif = 2;
                          if(this.debug) console.log("no usenotif from prefs: " + whenusenotif);
                          var elements = whenusenotiflist.getElementsByAttribute("value",whenusenotif);
                          whenusenotiflist.selectedItem = elements[0];                  
                  } 
                  if(this.debug) console.log("DQ: out onLoad");                  
          },
  };
}